
#include <windows.h>
#include <stdio.h>
#include "DbgPrnHk.h"
#include "DbgPrintLog.h"
#include "dbgprint_opt.h"
//#include "dbgprn_options.h"

#define pOpt     opt

int
DbgPrint_CmdLine_to_OptStruct(
    IN PWCHAR CmdLine,
    IN UCHAR  Reinit,
    OUT PDBGDUMP_OPT opt_struct
    )
{
    int argc;
    WCHAR** argv;
    LONG i=0;
    LONG j;
    WCHAR a;
    PDBGDUMP_OPT_RAW opt = (PDBGDUMP_OPT_RAW)opt_struct;
    PWCHAR eq_s;
    PWCHAR p_val;
    PWCHAR p_nam;
    WCHAR saved_a;
    ULONG d;

    switch(Reinit) {
    case DbgPrint_OptStruct_Reinit_Drv:
        #define DBGPRINT_DRV_OPT_RAW_INIT
        #include "dbgprint_opt_list.h"
        break;
    case DbgPrint_OptStruct_Reinit_All:
        #define DBGPRINT_OPT_RAW_INIT
        #include "dbgprint_opt_list.h"
        break;
    }

    if(CmdLine) {
        argv = CommandLineToArgvW(CmdLine, &argc);
    } else {
        argv = NULL;
        argc = 0;
    }
    for(i=1; i<argc; i++) {
        if(!argv[i] || argv[i][0] != '-') {
            if(!wcscmp(argv[i], L"/h") ||
               !wcscmp(argv[i], L"/?")) {
                goto show_help;
            }
            opt->LogFile = argv[i];
            continue;
        }
        if(!wcscmp(argv[i], L"-h") ||
           !wcscmp(argv[i], L"-?") ||
//           !wcscmp(argv[i], L"/h") ||
//           !wcscmp(argv[i], L"/?") ||
           !wcscmp(argv[i], L"--help")) {
show_help:
//            usage();
//            exit(0);
            return 0;
        } else
        if(!wcscmp(argv[i], L"--status")) {
//            usage();
//            exit(0);
            opt->display_status = TRUE;
            //return 0;
        } else
        if(!wcscmp(argv[i], L"--run:U") || 
           !wcscmp(argv[i], L"--run:user") ||
           !wcscmp(argv[i], L"--run:usr")) {
//            usage();
//            exit(0);
            opt->user_run = 1;
            //return 0;
        } else
        if(!wcscmp(argv[i], L"--run:S") || 
           !wcscmp(argv[i], L"--run:svc")) {
//            usage();
//            exit(0);
            opt->user_run = 2;
            //return 0;
        } else
        if(!wcscmp(argv[i], L"--nowait")) {
//            usage();
//            exit(0);
            opt->nowait_msg = TRUE;
            //return 0;
        } else
        if(!wcscmp(argv[i], L"-sm") ||
           !wcscmp(argv[i], L"--sync_mode")) {
            opt->sync_mode = TRUE;
        } else
        if(!wcscmp(argv[i], L"-wd") ||
           !wcscmp(argv[i], L"--working_directory")) {
            i++;
            if(i >= argc) {
                print_log("%S requires pathname\n", argv[i-1]);
                return -2;
            }
            if(opt->WDir) {
                GlobalFree(opt->WDir);
            }
            j = wcslen(argv[i])+1;
            opt->WDir = (PWCHAR)GlobalAlloc(GMEM_FIXED, j*sizeof(WCHAR));
            memcpy(opt->WDir, argv[i], j*sizeof(WCHAR));
            opt->WDir[j-1] = 0;
        } else
        if(!wcscmp(argv[i], L"-drvopt") ||
           !wcscmp(argv[i], L"--drvopt") ||
           !wcscmp(argv[i], L"--drv_opt") ||
           !wcscmp(argv[i], L"--opt:drv") ||
           !wcscmp(argv[i], L"--drv:opt")) {
            i++;
            eq_s = wcschr(argv[i], '=');
            if(eq_s) {
                saved_a = eq_s[0];
                eq_s[0] = 0;
                p_val = eq_s+1;
                p_nam = argv[i];
                d = 0;
                //eq_s[0] = 0;
            } else {
                saved_a = 0;
                p_val = argv[i+1];
                p_nam = argv[i];
                d = 1;
            }

            if(i >= argc) {
                print_log("%S requires parameter\n", argv[i-1]);
                return -2;
            }

            // recognize driver options and fill structure
            #define DBGPRINT_DRV_OPT_RAW_RECOGNIZE
            #include "dbgprint_opt_list.h"
            /* else */
            if(!wcscmp(argv[i], L"*")) {
                // Use all defaults
                #define DBGPRINT_DRV_OPT_RAW_INIT_WITH_APPLY
                // reinit values
                #define DBGPRINT_DRV_OPT_RAW_INIT
                #include "dbgprint_opt_list.h"
            } else {
                print_log("Invalid driver option %S\n", argv[i]);
                return -2;
            }
            
            opt->drv_opt = TRUE;
        } else
        if(!wcscmp(argv[i], L"-drv") ||
           !wcscmp(argv[i], L"--drv:inst") ||
           !wcscmp(argv[i], L"--drv:install")) {
            i++;
            if(i < argc) {
                if(!wcscmp(argv[i], L"1")) {
                    opt->drv_mode = SERVICE_BOOT_START;
                    opt->drv_very_first = TRUE;
                } else
                if(!wcscmp(argv[i], L"B")) {
                    opt->drv_mode = SERVICE_BOOT_START;
                } else
                if(!wcscmp(argv[i], L"S")) {
                    opt->drv_mode = SERVICE_SYSTEM_START;
                } else
                if(!wcscmp(argv[i], L"A")) {
                    opt->drv_mode = SERVICE_AUTO_START;
                } else
                if(!wcscmp(argv[i], L"M")) {
                    opt->drv_mode = SERVICE_DEMAND_START;
                } else
                if(!wcscmp(argv[i], L"U")) {
/*
                    if(sys_account) {
                        continue;
                    }
                    remove_driver();
*/
                    //opt->deinstall_drv = TRUE;
                    opt->drv_mode = SERVICE_DISABLED;
                    //continue;
                } else {
                    // revert to initial state
                    i--;
                }
            }
//            if(sys_account) {
//                continue;
//            }
            opt->install_drv = TRUE;
        } else
        if(!wcscmp(argv[i], L"--drv:uninst") ||
           !wcscmp(argv[i], L"--drv:deinst") ||
           !wcscmp(argv[i], L"--drv:uninstall") ||
           !wcscmp(argv[i], L"--drv:deinstall")) {

            opt->drv_mode = SERVICE_DISABLED;
            opt->install_drv = TRUE;
        } else
        if(!wcscmp(argv[i], L"-svc") ||
           !wcscmp(argv[i], L"--svc:inst") ||
           !wcscmp(argv[i], L"--svc:install")) {
            i++;
            if(i < argc) {
                if(!wcscmp(argv[i], L"U")) {
                    opt->svc_mode = SERVICE_DISABLED;
                } else
                if(!wcscmp(argv[i], L"A")) {
                    opt->svc_mode = SERVICE_AUTO_START;
                } else
                if(!wcscmp(argv[i], L"M")) {
                    opt->svc_mode = SERVICE_DEMAND_START;
                } else {
                    // revert to initial state
                    i--;
                }
            }
            opt->install_svc = TRUE;
        } else
        if(!wcscmp(argv[i], L"--svc:uninst") ||
           !wcscmp(argv[i], L"--svc:deinst") ||
           !wcscmp(argv[i], L"--svc:uninstall") ||
           !wcscmp(argv[i], L"--svc:deinstall")) {

            opt->svc_mode = SERVICE_DISABLED;
            opt->install_svc = TRUE;
        } else
/*
        if(!wcscmp(argv[i], L"-run_mode")) {
            i++;
            if(i < argc) {
                if(!wcscmp(argv[i], L"S")) {
                    force_run_mode = TRUE;
                    run_mode_svc = TRUE;
                } else
                if(!wcscmp(argv[i], L"A")) {
                    force_run_mode = TRUE;
                    run_mode_svc = FALSE;
                } else
                {
                    return -2;
                }
            }
        } else
*/
        if(!wcscmp(argv[i], L"-no_drv") ||
           !wcscmp(argv[i], L"--no_drv") ||
           !wcscmp(argv[i], L"--drv:noload")) {
            opt->without_driver = TRUE;
        } else
        if(!wcsicmp(argv[i], L"-s") ||
           !wcsicmp(argv[i], L"--max_log_size")) {
            if(argv[i][1] == 'S') {
prealloc_log_size:
                opt->prealloc_mode = TRUE;
            }
            i++;
            if(i >= argc) {
                print_log("%S requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->MaxLogSize);
            if(!opt->MaxLogSize || opt->MaxLogSize > 2047) {
                print_log("Invalid %S value: %S\n", argv[i-1], argv[i]);
                return -2;
            }
        } else
        if(!wcscmp(argv[i], L"--prealloc_log_size")) {
            goto prealloc_log_size;
        } else
        if(!wcscmp(argv[i], L"-x") ||
           !wcscmp(argv[i], L"--build_index")) {
            opt->use_index = TRUE;
        } else
        if(!wcscmp(argv[i], L"-l") ||
           !wcscmp(argv[i], L"--max_log_count") ||
           !wcscmp(argv[i], L"--log_rotate_count")) {
            i++;
            if(i >= argc) {
                print_log("%S requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->MaxLogs);
        } else
        if(!wcscmp(argv[i], L"-n") ||
           !wcscmp(argv[i], L"--initial_log_number")) {
            i++;
            if(i >= argc) {
                print_log("%S requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->StartLogNum);
        } else
        if(!wcscmp(argv[i], L"-ovw") ||
           !wcscmp(argv[i], L"--overwrite_old_log")) {
            opt->overwrite_old = TRUE;
        } else
        if(!wcscmp(argv[i], L"-ft") ||
           !wcscmp(argv[i], L"--flush_timeout")) {
            i++;
            if(i >= argc) {
                print_log("%S requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->FlushTimeout);
        } else
        if(!wcscmp(argv[i], L"-cf") ||
           !wcscmp(argv[i], L"--out:both")) {
            opt->output_file = TRUE;
            opt->output_stdout = TRUE;
        } else
        if(!wcscmp(argv[i], L"--stdout") ||
           !wcscmp(argv[i], L"-o") ||
           !wcscmp(argv[i], L"--out:stdout")) {
            opt->output_file = FALSE;
            opt->output_stdout = TRUE;
            opt->output_none = FALSE;
        } else
        if(!wcscmp(argv[i], L"--no_out") ||
           !wcscmp(argv[i], L"--out_none") ||
           !wcscmp(argv[i], L"--out:none")) {
            opt->output_file = FALSE;
            opt->output_stdout = FALSE;
            opt->output_none = TRUE;
        } else
        if(!wcscmp(argv[i], L"--in_drv") ||
           !wcscmp(argv[i], L"--in:drv")) {
            opt->input_driver = TRUE;
            opt->input_file   = FALSE;
            opt->input_stdin  = FALSE;
        } else
        if(!wcscmp(argv[i], L"--stdin") ||
           !wcscmp(argv[i], L"--in:stdin")) {
            opt->input_driver = FALSE;
            opt->input_file   = FALSE;
            opt->input_stdin  = TRUE;
            opt->without_driver = FALSE;
            opt->log_time_perf = TRUE;
        } else
        if(!wcscmp(argv[i], L"-in_file") ||
           !wcscmp(argv[i], L"--in_file") ||
           !wcscmp(argv[i], L"--in:file")) {
            i++;
            if(i >= argc) {
                print_log("%S requires filename\n", argv[i-1]);
                return -1;
            }
            if(opt->input_FileName) {
                GlobalFree(opt->input_FileName);
            }
            j = wcslen(argv[i])+1;
            opt->input_FileName = (PWCHAR)GlobalAlloc(GMEM_FIXED, j*sizeof(WCHAR));
            memcpy(opt->input_FileName, argv[i], j*sizeof(WCHAR));
            opt->input_FileName[j-1] = 0;

            opt->input_driver = FALSE;
            opt->input_file   = TRUE;
            opt->input_stdin  = FALSE;
            opt->without_driver = FALSE;
            opt->log_time_perf = TRUE;
        } else
        if(!wcscmp(argv[i], L"--no_header")/* ||
           !wcscmp(argv[i], L"--header:off")*/) {
            opt->skip_header = TRUE;
        } else

//        #define ARG_OPT_UNICODE
        #include "fmt_output_opt.h"

        if(!wcscmp(argv[i], L"-rd") ||
           !wcscmp(argv[i], L"--drv:reload")) {
            opt->restart_drv = TRUE;
        } else
        if(!wcscmp(argv[i], L"-rc") ||
           !wcscmp(argv[i], L"--drv:reconfig")) {
            opt->change_config = TRUE;

        } else {
            //print_log("Unrecognized option: %S\n", argv[i]);
            return 0;
        }
    }
    return 1;
} // end DbgPrint_CmdLine_to_OptStruct()

VOID
DbgPrint_Cleanup_OptStruct(
    OUT PDBGDUMP_OPT opt_struct
    )
{
    PDBGDUMP_OPT_RAW opt = (PDBGDUMP_OPT_RAW)opt_struct;

} // end DbgPrint_Cleanup_OptStruct()